<?php

function __autoload($f) {
    //load the interfaces first otherwise contract errors occur
    $interfaceFile = "classes/interface/" . $f . "Interface.php";

    if (file_exists($interfaceFile)) {
        require_once $interfaceFile;
    }

    //load class files after interfaces
    $classFile = "classes/" . $f . ".php";
    if (file_exists($classFile)) {
        require_once $classFile;
    }

    //if utilities are needed load them last
    $utilFile = "classes/util/" . $f . ".php";
    if (file_exists($utilFile)) {
        require_once $utilFile;
    }
}


if(extension_loaded('gmp') && !defined('USE_EXT')){
    define ('USE_EXT', 'GMP');
}else if(extension_loaded('bcmath') && !defined('USE_EXT')){
    define ('USE_EXT', 'BCMATH');
}

$post_R1x = $_POST["R1x"];
$post_R1y = $_POST["R1y"];
$post_x1 = $_POST["x1"]; // this is used to create the public key, but since we have hardcoded it, its not necessary to deal with this.



//elliptic curve parameters
$Qx = '6174796913462593303486602434131194488337606921407879712879'; //public key x til BOB med passord 'hemmelig'
$Qy = '4571935574014424850307214357578070306631117006599250439368'; //public key y til BOB
$G = NISTcurve::generator_192(); //generator
$curve_192 = NISTcurve::curve_192(); //We use NIST recommended curve P-192
$Q = new Point($curve_192, $Qx, $Qy); //public key for BOB



function generate_R_and_s2 ($R1x, $R1y) {
 global $G, $curve_192;
 $R1 = new Point($curve_192, $R1x, $R1y); //public point
 $k2 = rand(0, 99999);
// $k2 = '266534496353336689597505767135253851561332439464211122018';
 $x2 = bcmath_Utils::bchexdec(hash('sha256', 'serverhemmelig', false));  //this is the other half of the 'shared-password" setup.
 $R = Point::add($R1,Point::mul($k2, $G));
 $hashinput = '('. $R->getX(). ',' . $R->getY(). ')';
 $h2 = bcmath_Utils::bchexdec(hash('sha256', $hashinput , false));
 $s2 = bcadd(bcmul($h2, $x2), $k2);
 return $R->getX().'|'.$R->getY().'|'.$s2;
}



echo generate_R_and_s2($post_R1x, $post_R1y);


?>