<?php

session_start();

function __autoload($f) {
    //load the interfaces first otherwise contract errors occur
    $interfaceFile = "classes/interface/" . $f . "Interface.php";

    if (file_exists($interfaceFile)) {
        require_once $interfaceFile;
    }

    //load class files after interfaces
    $classFile = "classes/" . $f . ".php";
    if (file_exists($classFile)) {
        require_once $classFile;
    }

    //if utilities are needed load them last
    $utilFile = "classes/util/" . $f . ".php";
    if (file_exists($utilFile)) {
        require_once $utilFile;
    }
}


if(extension_loaded('gmp') && !defined('USE_EXT')){
    define ('USE_EXT', 'GMP');
}else if(extension_loaded('bcmath') && !defined('USE_EXT')){
    define ('USE_EXT', 'BCMATH');
}



$Qx = '6174796913462593303486602434131194488337606921407879712879';
$Qy = '4571935574014424850307214357578070306631117006599250439368';
$G = NISTcurve::generator_192();
$curve_192 = NISTcurve::curve_192();
$Q = new Point($curve_192, $Qx, $Qy);



function verify_signature($Rx, $Ry, $s, $ch, $site) {
GLOBAL $curve_192, $Q, $G;

$H1 = hash_1($ch,$site);
$h2_input = '('. $Rx . ',' . $Ry. ')';
$h2 = bcmath_Utils::bchexdec(hash('sha256', $h2_input, false));
$R = new Point($curve_192, $Rx, $Ry);
$left =  Point::add($H1, Point::mul($s, $G));
$right = Point::add($R, Point::mul($h2,$Q));
if ($left->x == $right->x && $left->y == $right->y) {return true;}
else return false;
}



function hash_1($ch, $site){
GLOBAL $G, $curve_192;

$a = $curve_192->getA();
$b = $curve_192->getB();
$p = $curve_192->getPrime();
$hash = bcmath_Utils::bchexdec(hash('sha256', $ch.$site, false));
$t = '1569275433846670190958947355801916604020977175097581240320';
$exp = bcdiv(bcsub($p,'1'),'2');
$pre_z = bcadd(bcadd(bcpow($hash,"3"), bcmul($a,$hash)),$b);
$z = bcmod($pre_z, $p);
$remainder = bcpowmod($z, $exp, $p);

while ($remainder != 1) {
$hash = bcadd($hash,'1');
$pre_z = bcadd(bcadd(bcpow($hash,"3"), bcmul($a,$hash)),$b);
$z = bcmod($pre_z, $p);
$remainder = bcpowmod($z, $exp, $p);
}

$y = bcpowmod($z, $t, $p);
return new Point($curve_192, bcmod($hash,$p), $y);

}

if ($_GET['action'] == "docsign")
{
$sigver = verify_signature($_GET['Rx'], $_GET['Ry'], $_GET['s'], $_SESSION['documenttxt'], '');
if ($sigver === true) {
header("Location: index.php?action=docsignsuccess");}
else die('Document signature verification failed!');
}


if (!isset($_SESSION['ch']))
{
 die('No challenge detected for current session');
}



if (!isset($_GET['Rx']) || !isset($_GET['Ry']) || !isset($_GET['s']))
{
 die('missing signature');
}



$sigver = verify_signature($_GET['Rx'], $_GET['Ry'], $_GET['s'], $_SESSION['ch'], $_SESSION['site']);
if ($sigver === true) {
$_SESSION['auth'] = "true";
header("Location: index.php");}
else die('signature verification failed!');

?>